RectangleMorph subclass: #ScrabbleBoardBoxMorph
	instanceVariableNames: 'posInBoard wordMultiplier letterMultiplier '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Scrabble'!
!ScrabbleBoardBoxMorph commentStamp: '<historical>' prior: 0!
My instances are Boxes of a Scrabble Board!


!ScrabbleBoardBoxMorph methodsFor: 'initialization' stamp: 'JMV 6/22/1999 20:37'!
initColor
	"Initalize color"

	self color: (Color r:1 g:1 b:0.8).
	self letterMultiplier = 2 ifTrue: [
		self color: (Color r:0 g:1 b:1).
		self setBalloonText: 'Double Letter Score'.
	].
	self letterMultiplier = 3 ifTrue: [
		self color: (Color r:0.4 g:0.6 b:1).
		self setBalloonText: 'Triple Letter Score'.
	].
	self wordMultiplier = 2 ifTrue: [
		self color: (Color r:1 g:0.6 b:0.8).
		self setBalloonText: 'Double Word Score'.
	].
	self wordMultiplier = 3 ifTrue: [
		self color: (Color r:1 g:0.3 b:0.4).
		self setBalloonText: 'Triple Word Score'.
	].! !

!ScrabbleBoardBoxMorph methodsFor: 'initialization' stamp: 'JMV 4/1/2000 18:32'!
initialize
	"Inicialize a box"

	super initialize.
	self extent: 50@50.
	self initColor.! !


!ScrabbleBoardBoxMorph methodsFor: 'accessing' stamp: 'JMV 7/14/1999 19:56'!
letterMultiplier

	letterMultiplier isNil ifTrue: [letterMultiplier _ 1].
	^ letterMultiplier! !

!ScrabbleBoardBoxMorph methodsFor: 'accessing' stamp: 'JMV 6/22/1999 20:37'!
letterMultiplier: aNumber

	letterMultiplier _ aNumber.
	wordMultiplier _ 1.
	self initColor.! !

!ScrabbleBoardBoxMorph methodsFor: 'accessing' stamp: 'JMV 3/26/2000 10:24'!
posInBoard

	^ posInBoard! !

!ScrabbleBoardBoxMorph methodsFor: 'accessing' stamp: 'JMV 3/26/2000 10:24'!
posInBoard: aPoint
	"Set my position"

	posInBoard _ aPoint! !

!ScrabbleBoardBoxMorph methodsFor: 'accessing' stamp: 'JMV 7/16/1999 12:02'!
tile
	"Answer my tile, or nil if none "

	^ self submorphCount > 0 ifTrue: [
		self firstSubmorph ]
	ifFalse: [ nil ].! !

!ScrabbleBoardBoxMorph methodsFor: 'accessing' stamp: 'JMV 7/16/1999 19:23'!
tile: aScrabbleTileMorph
	"Add a tile"

	aScrabbleTileMorph position: self position.
	aScrabbleTileMorph extent: self extent.
	self addMorph: aScrabbleTileMorph.! !

!ScrabbleBoardBoxMorph methodsFor: 'accessing' stamp: 'JMV 7/14/1999 19:56'!
wordMultiplier

	wordMultiplier isNil ifTrue: [wordMultiplier _ 1].
	^ wordMultiplier! !

!ScrabbleBoardBoxMorph methodsFor: 'accessing' stamp: 'JMV 6/22/1999 20:37'!
wordMultiplier: aNumber

	wordMultiplier _ aNumber.
	letterMultiplier _ 1.
	self initColor.! !


!ScrabbleBoardBoxMorph methodsFor: 'dropping/grabbing' stamp: 'JMV 4/1/2000 18:36'!
acceptDroppingMorph: aMorph event: evt
	"Receive a tile by Drag and Drop."

	| letter |
	self tile: aMorph.
	aMorph letter = $  ifTrue: [
		letter _ ((FillInTheBlankMorph 
			request: 'What letter do you want?'
			initialAnswer: ''
			centerAt: Sensor cursorPoint - (0@70)),'A') asUppercase first.
		aMorph letter: letter score: 0.
		self owner owner class = ScrabbleGameMorph ifTrue: [
			ServerManager current
				sendTo: aMorph tileID
				message: #letterString:
				withArguments: (Array with: letter asString) ].
	].
	
	"aMorph lock only after the move is confirmed!!"

	self owner owner class = ScrabbleGameMorph ifTrue: [
		ServerManager current
			sendTo: self owner owner gameID
			message: #tileWasMoved:by:x:y:
			withArguments: (Array 
				with: aMorph tileID 
				with: self owner owner owner personID
				with: self posInBoard x asString
				with: self posInBoard y asString) ].! !

!ScrabbleBoardBoxMorph methodsFor: 'dropping/grabbing' stamp: 'JMV 6/22/1999 20:37'!
allowSubmorphExtraction
	"Allow to remove the tile (if not locked!!)."

	^ true! !

!ScrabbleBoardBoxMorph methodsFor: 'dropping/grabbing' stamp: 'JMV 7/16/1999 12:03'!
wantsDroppedMorph: aMorph event: evt
	"Only if I receive a tile, and I don't already have one!!."

	^ self tile isNil! !


!ScrabbleBoardBoxMorph methodsFor: 'change reporting' stamp: 'JMV 3/26/2000 10:25'!
ownerChanged
	"Our owner changed in some way. We reposition in it."

	| newExtent |
	self owner class = ScrabbleBoardMorph ifTrue: [
		newExtent _ (self owner extent / self owner boardSize) truncated.
		"This was too slow!!"
		"self position: self owner position + ((self posInBoard - (1@1)) * newExtent).
		self extent: newExtent."
		self privateBounds:
			(self owner position + ((self posInBoard - (1@1)) * newExtent) extent: newExtent).
		self submorphsDo: [ :each | each ownerChanged ].
	].! !


RectangleMorph subclass: #ScrabbleBoardMorph
	instanceVariableNames: 'boardSize boardID boxes '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Scrabble'!
!ScrabbleBoardMorph commentStamp: '<historical>' prior: 0!
My instances are Scrabble Boards!


!ScrabbleBoardMorph methodsFor: 'initialization' stamp: 'JMV 4/15/2000 10:31'!
addScrabbleBoardBoxes
	"Prepare the boxes"

	| letterMultiplier wordMultiplier aScrabbleBoardBox letterMultipliers wordMultipliers |
	boardSize isNil ifTrue: [boardSize _ 15@15].
	letterMultipliers _ Array new: boardSize x.
	1 to: boardSize x do: [ :x |
		letterMultipliers at: x put: (Array new: boardSize y).
		1 to: boardSize y do: [ :y |
			(letterMultipliers at: x) at: y put: 1. ] ].
	wordMultipliers _ Array new: boardSize x.
	1 to: boardSize x do: [ :x |
		wordMultipliers at: x put: (Array new: boardSize y).
		1 to: boardSize y do: [ :y |
			(wordMultipliers at: x) at: y put: 1. ] ].

	self prepareLetterMultipliers: letterMultipliers wordMultipliers: wordMultipliers.
	boxes _ Array new: boardSize x * boardSize y.
	1 to: boardSize x do: [ :x |
		1 to: boardSize y do: [ :y |
			letterMultiplier _ (letterMultipliers at: x) at: y.
			wordMultiplier _ (wordMultipliers at: x) at: y.
			aScrabbleBoardBox _ ScrabbleBoardBoxMorph new.
			aScrabbleBoardBox posInBoard: (x@y).
			letterMultiplier > 1 ifTrue: [ aScrabbleBoardBox letterMultiplier: letterMultiplier ].
			wordMultiplier > 1 ifTrue: [ aScrabbleBoardBox wordMultiplier: wordMultiplier ].
			boxes at: (y-1)*(boardSize x) + x put: aScrabbleBoardBox.
		].
	].
	self addAllMorphs: boxes.! !

!ScrabbleBoardMorph methodsFor: 'initialization' stamp: 'JMV 3/26/2000 09:51'!
boardID: anObjectID
	"Set the ID of my board"

	| dimString dim |
	boardID _ anObjectID.
	dimString _ ServerManager current
		sendTo: boardID
		message: #size
		withArguments: #().
	dim _ dimString asNumber.
	boardSize _ dim@dim.
	self addScrabbleBoardBoxes.
	self extent: 390@390.! !

!ScrabbleBoardMorph methodsFor: 'initialization' stamp: 'JMV 3/26/2000 10:04'!
prepareLetterMultipliers: letterMultipliers wordMultipliers: wordMultipliers
	"Prepare board multipliers "

	| aSet excedent mult |
	excedent _ (self boardSize x - 15) / 2.

	"Prepare a conventional board at the center"
	aSet _ Set new.
	self class premiumLetterBoxes2 do: [ :aPoint | aSet add: aPoint].
	self class premiumLetterBoxes2 do: [ :aPoint | aSet add: aPoint * (-1@1) + (16@0)].
	self class premiumLetterBoxes2 do: [ :aPoint | aSet add: aPoint * (1@-1) + (0@16)].
	self class premiumLetterBoxes2 do: [ :aPoint | aSet add: aPoint * (-1@-1) + (16@16)].
	aSet do: [ :aPoint | 
		(letterMultipliers at: aPoint x + excedent) at: aPoint y+ excedent put: 2].

	aSet _ Set new.
	self class premiumLetterBoxes3 do: [ :aPoint | aSet add: aPoint].
	self class premiumLetterBoxes3 do: [ :aPoint | aSet add: aPoint * (-1@1) + (16@0)].
	self class premiumLetterBoxes3 do: [ :aPoint | aSet add: aPoint * (1@-1) + (0@16)].
	self class premiumLetterBoxes3 do: [ :aPoint | aSet add: aPoint * (-1@-1) + (16@16)].
	aSet do: [ :aPoint | 
		(letterMultipliers at: aPoint x + excedent) at: aPoint y+ excedent put: 3].

	aSet _ Set new.
	self class premiumWordBoxes2 do: [ :aPoint | aSet add: aPoint].
	self class premiumWordBoxes2 do: [ :aPoint | aSet add: aPoint * (-1@1) + (16@0)].
	self class premiumWordBoxes2 do: [ :aPoint | aSet add: aPoint * (1@-1) + (0@16)].
	self class premiumWordBoxes2 do: [ :aPoint | aSet add: aPoint * (-1@-1) + (16@16)].
	aSet do: [ :aPoint | 
		(wordMultipliers at: aPoint x + excedent) at: aPoint y+ excedent put: 2].

	aSet _ Set new.
	self class premiumWordBoxes3 do: [ :aPoint | aSet add: aPoint].
	self class premiumWordBoxes3 do: [ :aPoint | aSet add: aPoint * (-1@1) + (16@0)].
	self class premiumWordBoxes3 do: [ :aPoint | aSet add: aPoint * (1@-1) + (0@16)].
	self class premiumWordBoxes3 do: [ :aPoint | aSet add: aPoint * (-1@-1) + (16@16)].
	aSet do: [ :aPoint | 
		(wordMultipliers at: aPoint x + excedent) at: aPoint y+ excedent put: 3].


	1 to: excedent do: [ :i |
		1 to: 15+i do: [ :j |
			mult _ (letterMultipliers at: excedent-i+1+7) at: excedent+j.
			mult > 1 ifTrue: [
				(letterMultipliers at: excedent-i+1) at: excedent+j put: mult ].
			mult _ (wordMultipliers at: excedent-i+1+7) at: excedent+j.
			mult > 1 ifTrue: [
				(wordMultipliers at: excedent-i+1) at: excedent+j put: mult ].

			mult _ (letterMultipliers at: excedent+i+15-7) at: excedent+j.
			mult > 1 ifTrue: [
				(letterMultipliers at: excedent+i+15) at: excedent+j put: mult ].
			mult _ (wordMultipliers at: excedent+i+15-7) at: excedent+j.
			mult > 1 ifTrue: [
				(wordMultipliers at: excedent+i+15) at: excedent+j put: mult ].

			mult _ (letterMultipliers at: excedent+j) at: excedent-i+1+7.
			mult > 1 ifTrue: [
				(letterMultipliers at: excedent+j) at: excedent-i+1 put: mult ].
			mult _ (wordMultipliers at: excedent+j) at: excedent-i+1+7.
			mult > 1 ifTrue: [
				(wordMultipliers at: excedent+j) at: excedent-i+1 put: mult ].

			mult _ (letterMultipliers at: excedent+j) at: excedent+i+15-7.
			mult > 1 ifTrue: [
				(letterMultipliers at: excedent+j) at: excedent+i+15 put: mult ].
			mult _ (wordMultipliers at: excedent+j) at: excedent+i+15-7.
			mult > 1 ifTrue: [
				(wordMultipliers at: excedent+j) at: excedent+i+15 put: mult ].
		].

		mult _ (letterMultipliers at: excedent-i+1) at: excedent-i+1+7.
		mult > 1 ifTrue: [
			(letterMultipliers at: excedent-i+1) at: excedent-i+1 put: mult ].
		mult _ (wordMultipliers at: excedent-i+1) at: excedent-i+1+7.
		mult > 1 ifTrue: [
			(wordMultipliers at: excedent-i+1) at: excedent-i+1 put: mult ].

		mult _ (letterMultipliers at: excedent+i+15) at: excedent-i+1+7.
		mult > 1 ifTrue: [
			(letterMultipliers at: excedent+i+15) at: excedent-i+1 put: mult ].
		mult _ (wordMultipliers at: excedent+i+15) at: excedent-i+1+7.
		mult > 1 ifTrue: [
			(wordMultipliers at: excedent+i+15) at: excedent-i+1 put: mult ].

		mult _ (letterMultipliers at: excedent-i+1) at: excedent+i+15-7.
		mult > 1 ifTrue: [
			(letterMultipliers at: excedent-i+1) at: excedent+i+15 put: mult ].
		mult _ (wordMultipliers at: excedent-i+1) at: excedent+i+15-7.
		mult > 1 ifTrue: [
			(wordMultipliers at: excedent-i+1) at: excedent+i+15 put: mult ].

		mult _ (letterMultipliers at: excedent+i+15) at: excedent+i+15-7.
		mult > 1 ifTrue: [
			(letterMultipliers at: excedent+i+15) at: excedent+i+15 put: mult ].
		mult _ (wordMultipliers at: excedent+i+15) at: excedent+i+15-7.
		mult > 1 ifTrue: [
			(wordMultipliers at: excedent+i+15) at: excedent+i+15 put: mult ].
	].

	(wordMultipliers at: 1) at: 1 put: 3.
	(wordMultipliers at: self boardSize x) at: 1 put: 3.
	(wordMultipliers at: 1) at: self boardSize y put: 3.
	(wordMultipliers at: self boardSize x) at: self boardSize y put: 3.
	excedent > 3 ifTrue: [
		(wordMultipliers at: excedent+8) at: 1 put: 3.
		(wordMultipliers at: 1) at: excedent+8 put: 3.
		(wordMultipliers at: excedent+8) at: self boardSize y put: 3.
		(wordMultipliers at: self boardSize x) at: excedent+8 put: 3.
	].! !


!ScrabbleBoardMorph methodsFor: 'game' stamp: 'JMV 4/15/2000 10:34'!
newTiles

	| result tile |
	result _ OrderedCollection new.
	self boxes do: [ :each |
		tile _ each tile.
		(tile notNil and: [tile isLocked not]) ifTrue: [
			result add: tile ] ].
	^ result! !

!ScrabbleBoardMorph methodsFor: 'game' stamp: 'JMV 4/15/2000 10:34'!
newTilesInfo

	| result tile |
	result _ 'tiles'.
	self boxes do: [ :each |
		tile _ each tile.
		(tile notNil and: [tile isLocked not]) ifTrue: [
			result _ result, ' ', tile tileID, ' ',	
				each posInBoard x asString, ' ', each posInBoard y asString ] ].
	^ result! !


!ScrabbleBoardMorph methodsFor: 'accessing' stamp: 'JMV 7/14/1999 23:25'!
boardID

	^ boardID! !

!ScrabbleBoardMorph methodsFor: 'accessing' stamp: 'JMV 3/26/2000 09:52'!
boardSize

	^ boardSize! !

!ScrabbleBoardMorph methodsFor: 'accessing' stamp: 'JMV 3/26/2000 09:52'!
boardSize: aPoint

	boardSize _ aPoint! !

!ScrabbleBoardMorph methodsFor: 'accessing' stamp: 'JMV 4/15/2000 10:32'!
boxAt: aPoint

	^self boxes at: (aPoint y-1)*(boardSize x) + aPoint x! !

!ScrabbleBoardMorph methodsFor: 'accessing' stamp: 'JMV 4/15/2000 10:27'!
boxes

	^ boxes! !

!ScrabbleBoardMorph methodsFor: 'accessing' stamp: 'JMV 4/15/2000 10:33'!
tileWithID: aScrabbleTileID

	| tile result |
	self boxes do: [ :each |
		tile _ each tile.
		tile notNil ifTrue: [
			tile tileID = aScrabbleTileID ifTrue: [
				result _ tile ]]].
	^result! !

!ScrabbleBoardMorph methodsFor: 'accessing' stamp: 'JMV 4/15/2000 10:33'!
tiles

	| tile result |
	result _ OrderedCollection new.
	self boxes do: [ :each |
		tile _ each tile.
		tile notNil ifTrue: [
			result add: tile ]].
	^result! !


!ScrabbleBoardMorph methodsFor: 'geometry' stamp: 'JMV 4/1/2000 18:39'!
extent: aPoint
	"Round to a valid size"

	| newExtent |
	boardSize isNil ifTrue: [boardSize _ 15@15. self addScrabbleBoardBoxes].
	newExtent _ ((aPoint / self boardSize) rounded ) * self boardSize.
	^ super extent: newExtent.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ScrabbleBoardMorph class
	instanceVariableNames: ''!

!ScrabbleBoardMorph class methodsFor: 'misc' stamp: 'JMV 6/22/1999 20:40'!
premiumLetterBoxes2
	"Answer the coordinates for premium squares in the first cuadrant."

	^ { (4@1). (1@4). (7@3). (3@7). (7@7). (4@8). (8@4)}! !

!ScrabbleBoardMorph class methodsFor: 'misc' stamp: 'JMV 6/22/1999 20:40'!
premiumLetterBoxes3
	"Answer the coordinates for premium squares in the first cuadrant."

	^ { (6@2). (2@6). (6@6) }! !

!ScrabbleBoardMorph class methodsFor: 'misc' stamp: 'JMV 6/22/1999 20:40'!
premiumWordBoxes2
	"Answer the coordinates for premium squares in the first cuadrant."

	^ { (2@2). (3@3). (4@4). (5@5). (8@8) }! !

!ScrabbleBoardMorph class methodsFor: 'misc' stamp: 'JMV 6/22/1999 20:40'!
premiumWordBoxes3
	"Answer the coordinates for premium squares in the first cuadrant."

	^ { (1@1). (1@8). (8@1) }! !


RectangleMorph subclass: #ScrabbleGameCreationMorph
	instanceVariableNames: 'languageMorph dictionaryMorph playerQtyMorph maxPlayTimeMorph maxGameTimeMorph joinLimitTimeMorph gameID acceptMorph '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Scrabble'!

!ScrabbleGameCreationMorph methodsFor: 'field values' stamp: 'JMV 7/13/1999 20:11'!
dictionary
	"Answer the value the user entered in this widget"

	^ dictionaryMorph contents.! !

!ScrabbleGameCreationMorph methodsFor: 'field values' stamp: 'JMV 7/13/1999 20:11'!
joinLimitTime
	"Answer the value the user entered in this widget"

	^ joinLimitTimeMorph userString withBlanksTrimmed.! !

!ScrabbleGameCreationMorph methodsFor: 'field values' stamp: 'JMV 7/13/1999 20:11'!
language
	"Answer the value the user entered in this widget"

	^ languageMorph contents.! !

!ScrabbleGameCreationMorph methodsFor: 'field values' stamp: 'JMV 7/13/1999 20:11'!
maxGameTime
	"Answer the value the user entered in this widget"

	^ maxGameTimeMorph userString withBlanksTrimmed.! !

!ScrabbleGameCreationMorph methodsFor: 'field values' stamp: 'JMV 7/13/1999 20:11'!
maxTurnTime
	"Answer the value the user entered in this widget"

	^ maxPlayTimeMorph userString withBlanksTrimmed.! !

!ScrabbleGameCreationMorph methodsFor: 'field values' stamp: 'JMV 7/13/1999 20:10'!
playerQty
	"Answer the value the user entered in this widget"

	^ playerQtyMorph userString withBlanksTrimmed.! !


!ScrabbleGameCreationMorph methodsFor: 'user options' stamp: 'JMV 7/11/1999 22:40'!
dictionaries

	| options |
	options _ ServerManager current
		sendMessageToVirtualPlayroom: #scrabbleDictionaryNamesFor:
		withArguments: (Array with: self language).
	options = 'nil' ifTrue: [ 
		options _ OrderedCollection with: 'No options are available' ].
	^ options! !

!ScrabbleGameCreationMorph methodsFor: 'user options' stamp: 'JMV 7/11/1999 22:53'!
languages

	| options |
	options _ ServerManager current
		sendMessageToVirtualPlayroom: #languageNames
		withArguments: #().
	dictionaryMorph contents: 'Select'; extent: 120@16.
	^ options! !


!ScrabbleGameCreationMorph methodsFor: 'initialization' stamp: 'JMV 3/26/2000 09:29'!
createSubmorphs
	"Creates widgets"

	self addMorph: (StringMorph new 
		position: self position + (30@10); contents: 'New Scrabble Game'; 
		font: (StrikeFont familyName: #NewYork size: 26); yourself).
	self addMorph: (StringMorph new 
		position: self position + (20@50); contents: 'Language:'; yourself).
	self addMorph: (languageMorph _ BorderedPopUpChoiceMorph new
		position: self position + (150@50); contents: 'Select'; extent: 120@16;
		target: self; getItemsSelector: #languages; getItemsArgs: #(); yourself).
	self addMorph: (StringMorph new 
		position: self position + (20@70); contents: 'Dictionary:'; yourself).
	self addMorph: (dictionaryMorph _ BorderedPopUpChoiceMorph new
		position: self position + (150@70); contents: 'Select'; extent: 120@16; 
		target: self; getItemsSelector: #dictionaries; getItemsArgs: #(); yourself).
	self addMorph: (StringMorph new 
		position: self position + (20@90); contents: 'Player Qty:'; yourself).
	self addMorph: (RectangleMorph new
		position: self position + (150@90); extent: 120@16; color: Color white;
		addMorph: (playerQtyMorph _ TextMorph new
			contentsWrapped: ' 4'; fillingOnOff; yourself); yourself).
	self addMorph: (StringMorph new 
		position: self position + (20@110); contents: 'Max turn time:'; yourself).
	self addMorph: (RectangleMorph new
		position: self position + (150@110); extent: 120@16; color: Color white;
		addMorph: (maxPlayTimeMorph _ TextMorph new
			contentsWrapped: ' 5'; fillingOnOff; yourself); yourself).
	self addMorph: (StringMorph new 
		position: self position + (20@130); contents: 'Max game time:'; yourself).
	self addMorph: (RectangleMorph new
		position: self position + (150@130); extent: 120@16; color: Color white;
		addMorph: (maxGameTimeMorph _ TextMorph new
			contentsWrapped: ' 90'; fillingOnOff; yourself); yourself).
	self addMorph: (StringMorph new 
		position: self position + (20@150); contents: 'Join limit time:'; yourself).
	self addMorph: (RectangleMorph new
		position: self position + (150@150); extent: 120@16; color: Color white;
		addMorph: (joinLimitTimeMorph _ TextMorph new
			contentsWrapped: ' ',
				((Time now addTime: (Time fromSeconds: 900)) print24 truncateTo: 5);
			fillingOnOff; yourself); yourself).
	self addMorph: (acceptMorph _ SimpleButtonMorph new 
		position: self position + (50@190); label: 'Accept'; extent: 75@25; 
		target: self; actionSelector: #accept; yourself).
	self addMorph: (SimpleButtonMorph new 
		position: self position + (175@190); label: 'Cancel'; extent: 75@25; 
		target: self; actionSelector: #cancel; yourself).! !

!ScrabbleGameCreationMorph methodsFor: 'initialization' stamp: 'JMV 7/11/1999 19:53'!
initialize
	"Inicialize an instance"

	super initialize.
	self color: Color lightBlue.
	self extent: 300@240.
	self createSubmorphs.

! !


!ScrabbleGameCreationMorph methodsFor: 'processing' stamp: 'JMV 7/24/1999 12:20'!
accept
	"Create the game"

	((self dictionary = 'Select') |
	(self dictionary = 'No options are available') |
	gameID notNil |
	(self playerQty asNumber < 2) | 
	(self joinLimitTime asTime <= Time now)) ifTrue: [
		(SelectionMenu selections: #('Accept'))
			startUpWithCaption: 'Incorrect Data' ]
	ifFalse: [
		acceptMorph lock.
		gameID _ ServerManager current
			sendMessageToVirtualPlayroom: #createGameWithDictionary:playerQty:maxTurnTime:maxGameTime:joinLimitTime:
			withArguments: (Array with: self dictionary
				with: self playerQty
				with: self maxTurnTime
				with: self maxGameTime
				with: self joinLimitTime).
		ServerManager current
			sendTo: gameID
			message: #join:
			withArguments: (Array with: self owner personID).
		ServerManager current interestedPartiesInModelEvents at: gameID put: self.
	].! !

!ScrabbleGameCreationMorph methodsFor: 'processing' stamp: 'JMV 7/24/1999 11:44'!
cancel

	gameID isNil ifFalse: [
		ServerManager current
			sendTo: gameID
			message: #cancelGame
			withArguments: #().
		ServerManager current interestedPartiesInModelEvents removeKey: gameID.
		gameID _ nil.
	].
	self delete.! !


!ScrabbleGameCreationMorph methodsFor: 'model events' stamp: 'JMV 7/24/1999 12:26'!
eventOccuredIn: anObjectID name: aSymbol arguments: anArgsArray
	"Event response"

	| aMorph |
	(anObjectID = gameID) ifTrue: [

		(aSymbol = #gameStarted) ifTrue: [
			self owner gameMorph: (aMorph _ ScrabbleGameMorph new).
			aMorph gameID: gameID.
			(self owner personID = (anArgsArray at: 1)) ifTrue: [
				aMorph yourTurn ].
			self delete ].

		(aSymbol = #gameCancelled) ifTrue: [
			(SelectionMenu selections: #('Accept'))
				startUpWithCaption: 'The game was cancelled'
			ServerManager current interestedPartiesInModelEvents removeKey: gameID.
			gameID _ nil.
			self delete ].
	].! !


RectangleMorph subclass: #ScrabbleGameJoinMorph
	instanceVariableNames: 'gameMorph options gameIDs gameID acceptMorph '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Scrabble'!

!ScrabbleGameJoinMorph methodsFor: 'initialization' stamp: 'JMV 3/26/2000 12:14'!
createSubmorphs
	"Creates widgets"

	self addMorph: (StringMorph new 
		position: self position + (60@10); contents: 'Join Scrabble Game'; 
		font: (StrikeFont familyName: #NewYork size: 26); yourself).
	self addMorph: (StringMorph new 
		position: self position + (20@50); contents: 'Game:'; yourself).
	self addMorph: (gameMorph _ BorderedPopUpChoiceMorph new
		position: self position + (70@50); contents: 'Select'; extent: 250@16;
		target: self; getItemsSelector: #games; getItemsArgs: #(); yourself).
	self addMorph: (acceptMorph _ SimpleButtonMorph new 
		position: self position + (50@90); label: 'Accept'; extent: 75@25;
		target: self; actionSelector: #accept; yourself).
	self addMorph: (SimpleButtonMorph new 
		position: self position + (205@90); label: 'Cancel'; extent: 75@25; 
		target: self; actionSelector: #cancel; yourself).! !

!ScrabbleGameJoinMorph methodsFor: 'initialization' stamp: 'JMV 7/13/1999 22:09'!
initialize
	"Inicialize an instance"

	super initialize.
	self color: Color lightBlue.
	self extent: 340@140.
	self createSubmorphs.
! !


!ScrabbleGameJoinMorph methodsFor: 'field values' stamp: 'JMV 7/13/1999 22:32'!
game
	"Aswer the value entered by the user in this widget"

	^ gameMorph contents.! !


!ScrabbleGameJoinMorph methodsFor: 'model events' stamp: 'JMV 7/24/1999 12:25'!
eventOccuredIn: anObjectID name: aSymbol arguments: anArgsArray
	"Event response"

	| aMorph |
	(anObjectID = gameID) ifTrue: [

		(aSymbol = #gameStarted) ifTrue: [
			self owner gameMorph: (aMorph _ ScrabbleGameMorph new).
			aMorph gameID: gameID.
			(self owner personID = (anArgsArray at: 1)) ifTrue: [
				aMorph yourTurn ].
			self delete ].

		(aSymbol = #gameCancelled) ifTrue: [
			(SelectionMenu selections: #('Accept'))
				startUpWithCaption: 'The game was cancelled'.
			ServerManager current interestedPartiesInModelEvents removeKey: gameID.
			gameID _ nil.
			self delete ].
	].! !


!ScrabbleGameJoinMorph methodsFor: 'processing' stamp: 'JMV 7/24/1999 19:31'!
accept
	"Join the player to the game"

	((self game = 'Select') |
	(self game = 'No options are available') |
	gameID notNil ) ifTrue: [
		(SelectionMenu selections: #('Accept'))
			startUpWithCaption: 'Incorrect Date' ]
	ifFalse: [
		acceptMorph lock.
		gameID _ gameIDs at: (options indexOf: self game).
		ServerManager current
			sendTo: gameID
			message: #join:
			withArguments: (Array with: self owner personID).
		ServerManager current interestedPartiesInModelEvents at: gameID put: self.
	].! !

!ScrabbleGameJoinMorph methodsFor: 'processing' stamp: 'JMV 7/24/1999 11:42'!
cancel

	gameID isNil ifFalse: [
		ServerManager current
			sendTo: gameID
			message: #unJoin:
			withArguments: (Array with: self owner personID).
		ServerManager current interestedPartiesInModelEvents removeKey: gameID.
		gameID _ nil.
	].
	self delete.! !


!ScrabbleGameJoinMorph methodsFor: 'user options' stamp: 'JMV 7/13/1999 22:29'!
games

	| answer |
	answer _ ServerManager current
		sendMessageToVirtualPlayroom: #gamesOpenForJoin
		withArguments: #().
	answer isEmpty not ifTrue: [
		gameIDs _ Array new: answer size / 2.
		options _ Array new: answer size / 2.
		1 to: gameIDs size do: [ :i |
			gameIDs at: i put: (answer at: i*2-1).
			options at: i put: (answer at: i*2) ] ]
	ifFalse: [
		options _ OrderedCollection with: 'No options are available' ].
	^ options! !


RectangleMorph subclass: #ScrabbleGameMorph
	instanceVariableNames: 'gameID boardMorph rackMorph confirmPlayMorph exchangeMorph passMorph discarderMorph scoresMorph turnMorph '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Scrabble'!
!ScrabbleGameMorph commentStamp: '<historical>' prior: 0!
My instances are Scrabble Game!


!ScrabbleGameMorph methodsFor: 'initialization' stamp: 'JMV 7/16/1999 11:44'!
createBoard
	"Create board submorph"

	| boardID |
	boardID _ ServerManager current
			sendTo: gameID
			message: #board
			withArguments: #().
	self addMorph: (boardMorph _ ScrabbleBoardMorph new
		position: self position + (5@5); boardID: boardID; yourself).
! !

!ScrabbleGameMorph methodsFor: 'initialization' stamp: 'JMV 3/26/2000 12:21'!
createSubmorphs
	"Create submorphs"

	self addMorph: (rackMorph _ ScrabblePlayerRackMorph new
		position: self position + (86@400); yourself).

	self addMorph: (StringMorph new 
		position: self position + (410@10); contents: 'Game'; yourself).
	self addMorph: (confirmPlayMorph _ SimpleButtonMorph new 
		position: self position + (410@30); label: 'Confirm'; extent: 80@20; 
		target: self; actionSelector: #confirmPlay; yourself).
	self addMorph: (exchangeMorph _ SimpleButtonMorph new 
		position: self position + (410@60); label: 'Exchange'; extent: 80@20; 
		target: self; actionSelector: #changeTiles; yourself).
	self addMorph: (passMorph _ SimpleButtonMorph new 
		position: self position + (410@90); label: 'Pass'; extent: 80@20; 
		target: self; actionSelector: #pass; yourself).

	self addMorph: (StringMorph new 
		position: self position + (410@120); contents: 'Tile'; yourself).
	self addMorph: (StringMorph new 
		position: self position + (410@130); contents: 'Discarder'; yourself).
	self addMorph: (discarderMorph _ ScrabbleTileDiscarderMorph new 
		position: self position + (410@150); yourself).

	self addMorph: (StringMorph new 
		position: self position + (405@270); contents: 'Scores'; yourself).
	self addMorph: (scoresMorph _ ScrabbleScoresMorph new 
		position: self position + (405@290); yourself).

	self addMorph: (turnMorph _ StringMorph new 
		position: self position + (330@410); contents: ''; yourself).! !

!ScrabbleGameMorph methodsFor: 'initialization' stamp: 'JMV 7/16/1999 22:25'!
gameID: anObjectID
	"Assign game ID"

	| tilesIDs |
	gameID _ anObjectID.
	ServerManager current interestedPartiesInModelEvents at: gameID put: self.
	self createBoard.
	tilesIDs _ ServerManager current
			sendTo: gameID
			message: #tilesOfPlayer:
			withArguments: (Array with: self owner personID).
	rackMorph addScrabbleTileMorphsFor: tilesIDs.
	self notYourTurn.! !

!ScrabbleGameMorph methodsFor: 'initialization' stamp: 'JMV 7/16/1999 11:45'!
initialize
	"Inicialize an instance"

	super initialize.
	self color: Color orange.
	self borderWidth: 0.
	self extent: 500@440.
	self createSubmorphs.
! !


!ScrabbleGameMorph methodsFor: 'processing' stamp: 'JMV 7/24/1999 12:47'!
notYourTurn

	rackMorph lockTiles.
	confirmPlayMorph lock.
	exchangeMorph lock.
	passMorph lock.
	turnMorph contents: ''.! !

!ScrabbleGameMorph methodsFor: 'processing' stamp: 'JMV 3/26/2000 09:35'!
yourTurn

	rackMorph unlockTiles.
	confirmPlayMorph unlock.
	exchangeMorph unlock.
	passMorph unlock.
	turnMorph contents: 'Your Turn'.! !


!ScrabbleGameMorph methodsFor: 'accessing' stamp: 'JMV 7/16/1999 18:59'!
gameID

	^ gameID! !


!ScrabbleGameMorph methodsFor: 'game' stamp: 'JMV 7/17/1999 11:52'!
changeTiles

	| playData |
	playData _ discarderMorph tilesInfo.
	playData size > 6 ifTrue: [
		boardMorph newTilesInfo size > 6 ifFalse: [
			discarderMorph submorphsDo: [:each | each delete ].
			self notYourTurn.
			ServerManager current
				sendTo: gameID
				message: #changeTiles:
				withArguments: (Array with: playData).
		].
	].
! !

!ScrabbleGameMorph methodsFor: 'game' stamp: 'JMV 7/17/1999 11:37'!
confirmPlay

	| playData answer tiles |
	playData _ boardMorph newTilesInfo.
	playData size > 6 ifTrue: [
		discarderMorph tilesInfo size > 6 ifFalse: [
			self notYourTurn.
			answer _ ServerManager current
				sendTo: gameID
				message: #confirmPlay:
				withArguments: (Array with: playData).
			answer = 'invalid' ifTrue: [
				tiles _ boardMorph newTiles.
				rackMorph addAllMorphs: tiles.
				rackMorph layoutSubmorphs.
			].
		].
	].! !

!ScrabbleGameMorph methodsFor: 'game' stamp: 'JMV 7/17/1999 09:00'!
pass

	| playData |
	playData _ boardMorph newTilesInfo.
	playData size > 6 ifFalse: [
		self notYourTurn.
		ServerManager current
			sendTo: gameID
			message: #pass
			withArguments: #().
	].! !


!ScrabbleGameMorph methodsFor: 'model events' stamp: 'JMV 7/17/1999 08:55'!
eventConfirmedTilesWithArguments: anArgsArray
	"Event response"

	| tilesIDs |
	boardMorph newTiles do: [:each | each lock].
	(anArgsArray at: 1) = self owner personID ifTrue: [
		tilesIDs _ ServerManager current
			sendTo: gameID
			message: #tilesOfPlayer:
			withArguments: (Array with: self owner personID).
		rackMorph addScrabbleTileMorphsFor: tilesIDs.
		self notYourTurn.
	].! !

!ScrabbleGameMorph methodsFor: 'model events' stamp: 'JMV 7/17/1999 11:21'!
eventExchangedTilesWithArguments: anArgsArray
	"Event response"

	| tilesIDs |
	(anArgsArray at: 1) = self owner personID ifTrue: [
		tilesIDs _ ServerManager current
			sendTo: gameID
			message: #tilesOfPlayer:
			withArguments: (Array with: self owner personID).
		rackMorph addScrabbleTileMorphsFor: tilesIDs.
		self notYourTurn.
	].! !

!ScrabbleGameMorph methodsFor: 'model events' stamp: 'JMV 7/24/1999 13:45'!
eventGameEndedWithArguments: anArgsArray
	"Event response"

	(SelectionMenu selections: anArgsArray)
		startUpWithCaption: 'Scrabble winner is'.
	ServerManager current interestedPartiesInModelEvents removeKey: gameID.
	gameID _ nil.
	self delete.! !

!ScrabbleGameMorph methodsFor: 'model events' stamp: 'JMV 7/16/1999 19:46'!
eventMovedTileWithArguments: anArgsArray
	"Event response"

	| box tile |
	(anArgsArray at: 2) = self owner personID ifFalse: [
		box _ boardMorph boxAt: (Point 
			x: (anArgsArray at: 3) asNumber 
			y: (anArgsArray at: 4) asNumber ).
		tile _ boardMorph tileWithID: (anArgsArray at: 1).
		tile isNil ifTrue: [
			tile _ (ScrabbleTileMorph new 
				tileID: (anArgsArray at: 1); yourself) ].
		box tile: tile.
	].
! !

!ScrabbleGameMorph methodsFor: 'model events' stamp: 'JMV 7/17/1999 12:14'!
eventNextTurnWithArguments: anArgsArray
	"Event response"

	 (anArgsArray at: 1) = self owner personID ifTrue: [
		self yourTurn ].
	scoresMorph show: (anArgsArray at:2)! !

!ScrabbleGameMorph methodsFor: 'model events' stamp: 'JMV 7/17/1999 08:55'!
eventNotConfirmedTilesWithArguments: anArgsArray
	"Event response"

	(anArgsArray at: 1) = self owner personID ifFalse: [
		boardMorph newTiles do: [:each | each delete].
	].
! !

!ScrabbleGameMorph methodsFor: 'model events' stamp: 'JMV 7/24/1999 13:35'!
eventOccuredIn: anObjectID name: aSymbol arguments: anArgsArray
	"Event response"
"Transcript show: aSymbol asString;cr."
	(anObjectID = gameID) ifTrue: [
		aSymbol = #tileWasMoved ifTrue: [
			self eventMovedTileWithArguments: anArgsArray. ].
		aSymbol = #tileWasRemoved ifTrue: [
			self eventRemovedTileWithArguments: anArgsArray. ].
		aSymbol = #confirmedTiles ifTrue: [
			self eventConfirmedTilesWithArguments: anArgsArray. ].
		aSymbol = #notConfirmedTiles ifTrue: [
			self eventNotConfirmedTilesWithArguments: anArgsArray. ].
		aSymbol = #exchangedTiles ifTrue: [
			self eventExchangedTilesWithArguments: anArgsArray. ].
		aSymbol = #nextTurn ifTrue: [
			self eventNextTurnWithArguments: anArgsArray. ].
		aSymbol = #gameEnded ifTrue: [
			self eventGameEndedWithArguments: anArgsArray. ].	].! !

!ScrabbleGameMorph methodsFor: 'model events' stamp: 'JMV 7/16/1999 19:48'!
eventRemovedTileWithArguments: anArgsArray
	"Event response"

	| tile |
	(anArgsArray at: 2) = self owner personID ifFalse: [
		tile _ boardMorph tileWithID: (anArgsArray at: 1).
		tile isNil ifFalse: [ tile delete ].
	].
! !


RectangleMorph subclass: #ScrabbleLoginMorph
	instanceVariableNames: 'playRoomIPAddressMorph nameMorph passwordMorph '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Scrabble'!

!ScrabbleLoginMorph methodsFor: 'field values' stamp: 'JMV 7/11/1999 17:43'!
nickName
	"Answer the value the user entered in this widget"

	^ nameMorph userString withBlanksTrimmed.! !

!ScrabbleLoginMorph methodsFor: 'field values' stamp: 'JMV 7/11/1999 17:43'!
password
	"Answer the value the user entered in this widget"

	^ passwordMorph userString withBlanksTrimmed.! !

!ScrabbleLoginMorph methodsFor: 'field values' stamp: 'JMV 7/9/1999 19:26'!
playRoomIPAddress
	"Answer the value the user entered in this widget"

	^ NetNameResolver addressFromString: playRoomIPAddressMorph userString.! !


!ScrabbleLoginMorph methodsFor: 'processing' stamp: 'JMV 7/15/1999 23:03'!
accept
	"Accept input data"

	| answer roomMorph |
	ServerManager current connectToServer: self playRoomIPAddress.
	answer _ ServerManager current
		sendMessageToVirtualPlayroom: #validateLogin:password:
		withArguments: (Array with: self nickName with: self password).
	(answer beginsWith: 'invalid password') ifTrue: [
		ServerManager current disconnectFromServer.
		(SelectionMenu selections: #('Accept'))
			startUpWithCaption: 'Invalid Password']
	ifFalse: [
		roomMorph _ ScrabbleVirtualPlayroomMorph new.
		roomMorph personID: answer.
		World addMorph: roomMorph.
		World startStepping: roomMorph.
		self delete ].! !


!ScrabbleLoginMorph methodsFor: 'initialization' stamp: 'JMV 3/26/2000 09:21'!
createSubmorphs
	"Creates widgets"

	self addMorph: (StringMorph new 
		position: self position + (15@10); contents: 'Welcome to Scrabble'; 
		font: (StrikeFont familyName: #NewYork size: 26); yourself).

	self addMorph: (StringMorph new 
		position: self position + (20@50); contents: 'Play Room IP address:'; yourself).
	self addMorph: (RectangleMorph new
		position: self position + (150@50); extent: 120@16; color: Color white;
		addMorph: (playRoomIPAddressMorph _ TextMorph new
			contentsWrapped: ' 1.1.1.1'; fillingOnOff; yourself); yourself).

	self addMorph: (StringMorph new 
		position: self position + (20@70); contents: 'Name:'; yourself).
	self addMorph: (RectangleMorph new
		position: self position + (150@70); extent: 120@16; color: Color white;
		addMorph: (nameMorph _ TextMorph new
			contentsWrapped: ' Name'; fillingOnOff; yourself); yourself).

	self addMorph: (StringMorph new 
		position: self position + (20@90); contents: 'Password:'; yourself).
	self addMorph: (RectangleMorph new
		position: self position + (150@90); extent: 120@16; color: Color white;
		addMorph: (passwordMorph _ TextMorph new
			contentsWrapped: ' '; fillingOnOff; yourself); yourself).

	self addMorph: (SimpleButtonMorph new 
		position: self position + (50@130); label: 'Accept'; extent: 75@25; 
		target: self; actionSelector: #accept; yourself).
	self addMorph: (SimpleButtonMorph new 
		position: self position + (175@130); label: 'Cancel'; extent: 75@25; 
		target: self; actionSelector: #delete; yourself).! !

!ScrabbleLoginMorph methodsFor: 'initialization' stamp: 'JMV 7/13/1999 08:33'!
initialize
	"Inicialize an instance"

	super initialize.
	self color: Color lightBrown.
	self extent: 300@180.
	self createSubmorphs.! !


RectangleMorph subclass: #ScrabblePlayerRackMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Scrabble'!

!ScrabblePlayerRackMorph methodsFor: 'submorphs-add/remove' stamp: 'JMV 7/16/1999 22:22'!
addScrabbleTileMorphsFor: aScrabbleTilesIDCollection
	"Create and add tiles after IDs in the Server "

	self submorphsDo: [ :each | each delete ].
	aScrabbleTilesIDCollection do: [ :aScrabbleTileID |
		self addMorph: (ScrabbleTileMorph new 
			tileID: aScrabbleTileID; yourself) ].
	self layoutSubmorphs.! !

!ScrabblePlayerRackMorph methodsFor: 'submorphs-add/remove' stamp: 'JMV 7/16/1999 16:28'!
layoutSubmorphs
	"Layout tiles"

	self submorphs doWithIndex: [ :each :i |
		each extent: 32@32; position: self position + (2@2) + ((i-1) * (32@0));
		ownerChanged. ].! !

!ScrabblePlayerRackMorph methodsFor: 'submorphs-add/remove' stamp: 'JMV 7/15/1999 22:52'!
lockTiles
	"Lock tiles (probably not our turn)"

	self submorphs do: [ :each | each lock ].! !

!ScrabblePlayerRackMorph methodsFor: 'submorphs-add/remove' stamp: 'JMV 7/15/1999 22:52'!
unlockTiles
	"Unlock tiles (probably our turn)"

	self submorphs do: [ :each | each unlock ].! !


!ScrabblePlayerRackMorph methodsFor: 'initialization' stamp: 'JMV 7/17/1999 11:01'!
initialize
	"Inicialize an instance"

	super initialize.
	self color: Color black.
	self extent: 228@36.
! !


!ScrabblePlayerRackMorph methodsFor: 'dropping/grabbing' stamp: 'JMV 7/16/1999 19:56'!
acceptDroppingMorph: aMorph event: evt
	"Receive a tile by Drag and Drop."

	self addMorphBack: aMorph.
	self layoutSubmorphs.
	ServerManager current
		sendTo: self owner gameID
		message: #tileWasRemoved:by:
		withArguments: (Array 
			with: aMorph tileID 
			with: self owner owner personID).! !

!ScrabblePlayerRackMorph methodsFor: 'dropping/grabbing' stamp: 'JMV 7/11/1999 17:55'!
allowSubmorphExtraction
	"Allow to remove a tile."

	^ true! !

!ScrabblePlayerRackMorph methodsFor: 'dropping/grabbing' stamp: 'JMV 7/11/1999 17:56'!
wantsDroppedMorph: aMorph event: evt
	"Only if what I get is a tile, and I have less than 7!!."

	^ true! !


RectangleMorph subclass: #ScrabbleScoresMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Scrabble'!

!ScrabbleScoresMorph methodsFor: 'as yet unclassified' stamp: 'JMV 7/17/1999 12:00'!
initialize
	"Inicialize an instance"

	super initialize.
	self extent: 90@140.! !

!ScrabbleScoresMorph methodsFor: 'as yet unclassified' stamp: 'JMV 7/17/1999 12:11'!
show: aString

	| contents |
	contents _ aString substrings: (Character cr).
	self submorphsDo: [ :each | each delete].
	contents doWithIndex: [ :each : i |
		self addMorph: (StringMorph new 
			position: self position + (5@0)+(i*(0@10)); contents: each; yourself).].! !


RectangleMorph subclass: #ScrabbleTileDiscarderMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Scrabble'!

!ScrabbleTileDiscarderMorph methodsFor: 'as yet unclassified' stamp: 'JMV 7/17/1999 10:53'!
acceptDroppingMorph: aMorph event: evt
	"Receive a Tile by Drag and Drop."

	self addMorphBack: aMorph.
! !

!ScrabbleTileDiscarderMorph methodsFor: 'as yet unclassified' stamp: 'JMV 7/17/1999 10:53'!
allowSubmorphExtraction
	"Allow to extract the tile."

	^ true! !

!ScrabbleTileDiscarderMorph methodsFor: 'as yet unclassified' stamp: 'JMV 7/17/1999 11:58'!
initialize
	"Inicialize an instance"

	super initialize.
	self color: Color brown.
	self extent: 80@100.
! !

!ScrabbleTileDiscarderMorph methodsFor: 'as yet unclassified' stamp: 'JMV 7/17/1999 11:09'!
tilesInfo

	| result |
	result _ 'tiles'.
	self submorphsDo: [ :tile |
		result _ result, ' ', tile tileID].
	^ result! !

!ScrabbleTileDiscarderMorph methodsFor: 'as yet unclassified' stamp: 'JMV 7/17/1999 10:54'!
wantsDroppedMorph: aMorph event: evt
	"Only if what I receive is a tile."

	^ true! !


RectangleMorph subclass: #ScrabbleTileMorph
	instanceVariableNames: 'letter score tileID '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Scrabble'!
!ScrabbleTileMorph commentStamp: '<historical>' prior: 0!
My instances are Scrabble tiles!


!ScrabbleTileMorph methodsFor: 'initialization' stamp: 'JMV 6/22/1999 20:38'!
initialize
	"Inicialize an instance"

	super initialize.
	bounds _ 0@0 corner: 32@32.
	self color: (Color r:0.93 g:0.93 b:0).
	borderWidth _ 1.
	self letter: $A score: 5.! !

!ScrabbleTileMorph methodsFor: 'initialization' stamp: 'JMV 6/22/1999 20:39'!
letter: aCharacter score: aNumber

	letter _ aCharacter.
	score _ aNumber.
	self createSubmorphs.! !

!ScrabbleTileMorph methodsFor: 'initialization' stamp: 'JMV 7/16/1999 20:16'!
tileID: anObjectID
	"Initialize after a tile in the Server"

	| l p data |
	tileID _ anObjectID.
	data _ ServerManager current
		sendTo: anObjectID
		message: #data
		withArguments: #().
	data _ data stemAndNumericSuffix.
	l _ (data at: 1) first.
	p _ data at: 2.
	self letter: l score: p.! !


!ScrabbleTileMorph methodsFor: 'submorphs-add/remove' stamp: 'JMV 6/22/1999 20:38'!
createSubmorphs
	"Delete first, and then create necesary submorphs again"

	| letterMorph scoreMorph |
	self submorphsDo: [:each | each delete].
	letterMorph _ StringMorph
		contents: letter asString 
		font: (StrikeFont familyName: #NewYork size: self letterSize).
	letterMorph position: self center - (letterMorph extent // 2).
	self addMorph: letterMorph.
	letterMorph lock.
	self width >= 20 ifTrue: [
		scoreMorph _ StringMorph 
			contents: score asString
			font: (StrikeFont familyName: #NewYork size: self scoreSize).
		scoreMorph position: self bounds bottomRight - scoreMorph extent - (1@1).
		self addMorph: scoreMorph.
		scoreMorph lock.
	].! !


!ScrabbleTileMorph methodsFor: 'change reporting' stamp: 'JMV 6/22/1999 18:47'!
layoutChanged
	"Avoid an infinite recursion for updating the owner."

	fullBounds _ nil.! !

!ScrabbleTileMorph methodsFor: 'change reporting' stamp: 'JMV 7/11/1999 18:05'!
ownerChanged
	"Our owner changed in some way. We reposition in it."

	self owner class = ScrabbleBoardBoxMorph ifTrue: [
		self position: self owner position.
		self extent: self owner extent.
	].
	self createSubmorphs.! !


!ScrabbleTileMorph methodsFor: 'accessing' stamp: 'JMV 7/16/1999 20:04'!
letter

	^ letter! !

!ScrabbleTileMorph methodsFor: 'accessing' stamp: 'JMV 7/16/1999 12:54'!
tileID

	^ tileID! !


!ScrabbleTileMorph methodsFor: 'drawing' stamp: 'JMV 6/22/1999 20:23'!
letterSize
	"Aswer an appropiate font size for my letter"

	^ (self height * 7/8) truncated! !

!ScrabbleTileMorph methodsFor: 'drawing' stamp: 'JMV 6/22/1999 20:21'!
scoreSize
	"Answer an appropiate font size for my score"

	^ (self height / 2) truncated! !


RectangleMorph subclass: #ScrabbleVirtualPlayroomMorph
	instanceVariableNames: 'personID gameMorph '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Scrabble'!

!ScrabbleVirtualPlayroomMorph methodsFor: 'initialization' stamp: 'JMV 4/1/2000 19:25'!
createSubmorphs
	"Creates widgets"

	self addMorph: (StringMorph new
		position: self position + (130@10); contents: 'Scrabble Virtual Play Room';
		font: (StrikeFont familyName: #NewYork size: 26); yourself).

	self addMorph: (SimpleButtonMorph new 
		position: self position + (10@70); label: 'New Game'; extent: 80@20; 
		target: self; actionSelector: #createGame; yourself).
	self addMorph: (SimpleButtonMorph new 
		position: self position + (10@100); label: 'Join Game'; extent: 80@20; 
		target: self; actionSelector: #joinAGame; yourself).

	self addMorph: (SimpleButtonMorph new 
		position: self position + (10@150); label: 'Exit'; extent: 80@20; 
		target: self; actionSelector: #logoff; yourself).! !

!ScrabbleVirtualPlayroomMorph methodsFor: 'initialization' stamp: 'JMV 7/16/1999 11:39'!
initialize
	"Inicialize an instance"

	super initialize.
	self extent: 610@500.
	self createSubmorphs.! !


!ScrabbleVirtualPlayroomMorph methodsFor: 'processing' stamp: 'JMV 7/16/1999 11:41'!
createGame
	"The option was selected"

	self addMorph: (ScrabbleGameCreationMorph new
		position: self position + (200@120); yourself).! !

!ScrabbleVirtualPlayroomMorph methodsFor: 'processing' stamp: 'JMV 7/16/1999 11:41'!
joinAGame
	"The option was selected"

	self addMorph: (ScrabbleGameJoinMorph new
		position: self position + (180@170); yourself).! !

!ScrabbleVirtualPlayroomMorph methodsFor: 'processing' stamp: 'JMV 7/9/1999 20:34'!
logoff

	ServerManager current disconnectFromServer.
	self delete! !


!ScrabbleVirtualPlayroomMorph methodsFor: 'accessing' stamp: 'JMV 7/16/1999 11:16'!
gameMorph

	^ gameMorph! !

!ScrabbleVirtualPlayroomMorph methodsFor: 'accessing' stamp: 'JMV 7/16/1999 11:18'!
gameMorph: aMorph

	gameMorph _ aMorph.
	self addMorph: gameMorph.
	gameMorph position: self position + (100@50).! !

!ScrabbleVirtualPlayroomMorph methodsFor: 'accessing' stamp: 'JMV 7/9/1999 21:18'!
personID

	^ personID! !

!ScrabbleVirtualPlayroomMorph methodsFor: 'accessing' stamp: 'JMV 7/9/1999 21:18'!
personID: anObjectID

	personID _ anObjectID! !


!ScrabbleVirtualPlayroomMorph methodsFor: 'stepping and presenter' stamp: 'JMV 7/16/1999 23:52'!
step
	"Step one cycle. Dispatch any events that came from the Server"

	ServerManager current processOneCycle
! !

!ScrabbleVirtualPlayroomMorph methodsFor: 'stepping and presenter' stamp: 'JMV 7/21/1999 20:08'!
stepTime
	"Interval for event dispatch."

	^ 125! !


!ScrabbleVirtualPlayroomMorph methodsFor: 'dropping/grabbing' stamp: 'JMV 7/16/1999 11:11'!
rootForGrabOf: aMorph
	"This is to avoid moving the Play Room in the World!!"

	^ aMorph class ~= ScrabbleTileMorph
		ifTrue: [nil] 
		ifFalse: [ super rootForGrabOf: aMorph ].! !
